\chapter{Introduction}
\RUST is one of the most innovative tools for programmers in recent years. A manageable learning curve, 
its type and memory safety without resorting to a \rubbish, the integration of functional as well as 
object-oriented aspects and the resulting performance through its compiler make it an ideal tool for 
programming microcontrollers and embedded systems. \\ \\
This report deals with the application of \RUST on \pico, a microcontroller using the rp2040 microchip.
\begin{figure}[H]
	\centering
	\includesvg{./Pictures/rust-logo-blk.svg}
	\includesvg[width=0.2\textwidth]{./Pictures/Raspberry_Pi_Logo.svg}
\end{figure}

\section{Basic hardware}
To start basic, a few things are necessary:
\begin{itemize}
	\item A \pico like you can find \href{https://www.berrybase.de/raspberry-pi/raspberry-pi-mikrocontroller/boards/}{here}
	\item A \href{https://www.berrybase.de/breadboard-mit-400-kontakten?c=431}{Breadboard}
	\item Several \href{https://www.berrybase.de/40pin-jumper/dupont-kabel-male-female-trennbar?c=431}{male female jumper cable}
	\item Several \href{https://www.berrybase.de/40pin-jumper/dupont-kabel-male-male-trennbar}{male male jumper cable}
	\item Several resistors approx. 500 Ohm
	\item Some LEDs
\end{itemize}
You can probably find everything you need to get started 
\href{https://www.amazon.de/detaillierten-Online-Tutorials-One-Stop-Lernelektronik-Programmierung-Software-Ingenieure/dp/B094J982N4}{here}, 
too.

\section{Basic Software}
Ok, besides \RUST you need a few things to do something with the \pico. All listed examples were 
transferred to the \pico using an \linux distribution. Basically any operating system should work 
on which \RUST can be installed. Under most \linux distributions it works like this:
\begin{figure}[H]
	\begin{verbatim}
		curl --proto '=https' --tlsv1.2 -sSf https://sh.rustup.rs | sh
	\end{verbatim}
	\caption{shell script to install \RUST.}
\end{figure}
Furthermore, much work is done here with instructions from 
\href{https://docs.rust-embedded.org/book/intro/index.html}{the embedded RUST book}. in case of 
problems and difficulties, this should be consulted. The basic template for the project can be 
obtained from \href{https://github.com/rp-rs/rp2040-project-template}{here}. Additionally some 
\cargo tools have to be installed. If you want to program the \pico using another or a special 
\href{https://www.raspberrypi.com/products/debug-probe/}{debug-probe}, you also need the 
corresponding tool:
\begin{figure}[H]
	\begin{lstlisting}
cargo install probe-run
	\end{lstlisting}
	\caption{probe-run is used when programming the \pico using another device.}
\end{figure}
\begin{figure}[H]
	\begin{lstlisting}
rustup target install thumbv6m-none-eabi
	\end{lstlisting}
	\caption{Allows the linker, a downstream unit of the compiler, to generate a machine program for the correct chip.}
\end{figure}
\begin{figure}[H]
\begin{lstlisting}
cargo install flip-link
\end{lstlisting}
\caption{Flips the memory layout of embedded programs to protect against stack overflows}
\end{figure}
\begin{figure}[H]
\begin{lstlisting}
cargo install elf2uf2-rs --locked
\end{lstlisting}
\caption{This allows to flash a \pico without additional devices.}
\end{figure}
\section{Basic Usage}
First of all, it is important to be able to load the specified project:
\begin{figure}[H]
	\begin{lstlisting}

	\end{lstlisting}
	\caption{}
\end{figure}
